PRO HORZ, VALUE, MIN=MIN, MAX=MAX, ENDS=ENDS, _EXTRA=EXTRA, LONG=LONG

if N_PARAMS() lt 1 then begin
    print, 'HORZ, overplot horizontal line, usage: horz, value [,min=min,max=max,/ends,long=long]'
    print, '            (long will lengthen the endcaps by teh factor long, e.g. long=3'
    return
endif

y = fltarr(2) + VALUE
x = !x.crange

if keyword_set(MIN) eq 1 then x[0] = min
if keyword_set(MAX) eq 1 then x[1] = max

if keyword_set(ends) then begin
        endlength = (!y.crange[1]-!y.crange[0])/(15.*6.)
endif


if n_elements(value) eq 1 then begin
   djs_oplot, x, y, _EXTRA=EXTRA
   if keyword_set(ends) then begin
      if keyword_set(MIN) eq 1 then begin
         oplot_lines, [x[0]],[value+endlength],[x[0]],[value-endlength], _extra=extra
         if keyword_set(long) eq 1 then begin
            oplot_lines, [x[0]],[value+endlength*long],[x[0]],[value-endlength*long], _extra=extra
         endif
      endif
      if keyword_set(MAX) eq 1 then begin
         oplot_lines, [x[1]],[value+endlength],[x[1]],[value-endlength], _extra=extra
         if keyword_set(long) eq 1 then begin
            oplot_lines, [x[1]],[value+endlength*long],[x[1]],[value-endlength*long], _extra=extra
         endif
      endif
   endif
endif else begin
   ntmp = n_elements(value)
   for i=0, ntmp - 1 do begin
      y = fltarr(2) + VALUE[i]
      x = !x.crange
      djs_oplot, x, y, _EXTRA=EXTRA
      if keyword_set(ends) then begin
         if keyword_set(MIN) eq 1 then begin
            oplot_lines, [x[0]],[value+endlength],[x[0]],[value-endlength], _extra=extra
            if keyword_set(long) eq 1 then begin
               oplot_lines, [x[0]],[value+endlength*long],[x[0]],[value-endlength*long], _extra=extra
            endif
         endif
         if keyword_set(MAX) eq 1 then begin
            oplot_lines, [x[1]],[value+endlength],[x[1]],[value-endlength], _extra=extra
            if keyword_set(long) eq 1 then begin
               oplot_lines, [x[1]],[value+endlength*long],[x[1]],[value-endlength*long], _extra=extra
            endif
         endif
      endif
   endfor
endelse

END
