FUNCTION TakeAway, a, b  
; Caitlin Casey borrowed this from
; http://www.dfanning.com/tips/set_operations.html
; on 24 May 2007
; takeaway means
; = a and (not b) = elements in A but not in B

if n_params() eq 0 then begin
   print, "  takeaway.pro"
   print, "      result = takeaway(A,B)"
   print, "          A, B - input vectors or sets"
   print, "          result - everything in A and not in B"
   return, -1
endif

mina = Min(a, Max=maxa)
minb = Min(b, Max=maxb)
IF (minb GT maxa) OR (maxb LT mina) THEN RETURN, a ;No intersection...
r = Where((Histogram(a, Min=mina, Max=maxa) NE 0) AND $
          (Histogram(b, Min=mina, Max=maxa) EQ 0), count)
IF count eq 0 THEN RETURN, -1 ELSE RETURN, r + mina
END
