PRO OPLOT_LINES, X1, Y1, X2, Y2, _EXTRA=EXTRA, ENDS=ENDS
;x1,y1,x2,y2 must all have the same dimensions

if n_params() lt 1 then begin
    print, 'oplot_lines.pro      usage:  oplot_lines, x1, y1, x2, y2, _extra=extra'
    print, '        overplots line segments between arrays [x1,y1] and [x2,y2]'
    print, '    cmc - dec 2007'
    return
endif

n_lines = n_elements(x1)

xline = fltarr(n_lines,2)
yline = fltarr(n_lines,2)

xline[*,0] = x1
xline[*,1] = x2
yline[*,0] = y1
yline[*,1] = y2

for i=0, n_lines - 1 do djs_oplot, xline[i,*], yline[i,*], _extra=extra


END
