PRO VER, VALUE, MIN=MIN, MAX=MAX, _EXTRA=EXTRA

if N_PARAMS() lt 1 then begin
    print, ' VER - overplot a vertical line at the specificed value, usage: ver, value, [min=min,max=max,_extra=extra]'
    print, '       cmc - nov 2006'
    return
endif

nmin=0
nmax=0
if keyword_set(MIN) eq 1 then nmin = n_elements(min)
if keyword_set(MAX) eq 1 then nmax = n_elements(MAX)


if n_elements(value) eq 1 then begin
    x = fltarr(2) + VALUE
    y = !y.crange
    
    if keyword_set(MIN) eq 1 then y[0] = min
    if keyword_set(MAX) eq 1 then y[1] = max
    
    djs_oplot, x, y, _EXTRA=EXTRA
endif

if n_elements(value) gt 1 then begin

    ntmp = n_elements(value)
    for i=0, ntmp - 1 do begin
        x = fltarr(2) + VALUE[i]
        y = !y.crange
        if keyword_set(MIN) eq 1 and nmin le 1 then y[0] = min
        if keyword_set(MAX) eq 1 and nmax le 1 then y[1] = max
        if keyword_set(MIN) eq 1 and nmin gt 1 then y[0] = min[i]
        if keyword_set(MAX) eq 1 and nmax gt 1 then y[1] = max[i]
        djs_oplot, x, y, _EXTRA=EXTRA
    endfor


endif

END
